]> gitweb.factorcode.org Git - factor.git/blob - build.sh
build.sh: Add a compile option to compile only.
[factor.git] / build.sh
1 #!/usr/bin/env bash
2
3 # Programs returning != 0 will not cause script to exit
4 set +e
5
6 # Case insensitive string comparison
7 shopt -s nocaseglob
8 #shopt -s nocasematch
9
10 ECHO=echo
11 OS=
12 ARCH=
13 WORD=
14 GIT_PROTOCOL=${GIT_PROTOCOL:="git"}
15 GIT_URL=${GIT_URL:=$GIT_PROTOCOL"://factorcode.org/git/factor.git"}
16 SCRIPT_ARGS="$*"
17
18 REQUIRE_CLANG_VERSION=3.1
19
20 # return 1 on found
21 test_program_installed() {
22     if ! [[ -n $(type -p $1) ]] ; then
23         return 0;
24     fi
25     return 1;
26 }
27
28 # return 1 on found
29 test_programs_installed() {
30     local installed=0;
31     $ECHO -n "Checking for all($*)..."
32     for i in "$@" ;
33     do
34         test_program_installed $i
35         if [[ $? -eq 1 ]]; then
36             installed=$(( $installed + 1 ))
37         fi
38     done
39     if [[ $installed -eq $# ]] ; then
40         $ECHO "found!"
41         return 1
42     else
43         $ECHO "all not found."
44         return 0
45     fi
46 }
47
48 exit_script() {
49     if [[ $FIND_MAKE_TARGET = true ]] ; then
50         # Must be echo not $ECHO
51         echo $MAKE_TARGET;
52     fi
53     exit $1
54 }
55
56 ensure_program_installed() {
57     local installed=0;
58     $ECHO -n "Checking for any($*)..."
59     for i in "$@" ;
60     do
61         test_program_installed $i
62         if [[ $? -eq 1 ]]; then
63             $ECHO "found $i!"
64             installed=$(( $installed + 1 ))
65             return
66         fi
67     done
68     $ECHO "none found."
69     $ECHO -n "Install "
70     if [[ $# -eq 1 ]] ; then
71         $ECHO -n $1
72     else
73         $ECHO -n "any of [ $* ]"
74     fi
75     $ECHO " and try again."
76     if [[ $OS == macosx ]] ; then
77         $ECHO "If you have Xcode 4.3 or higher installed, you must install the"
78         $ECHO "Command Line Tools from Xcode Preferences > Downloads in order"
79         $ECHO "to build Factor."
80     fi
81     exit_script 1;
82 }
83
84 check_ret() {
85     RET=$?
86     if [[ $RET -ne 0 ]] ; then
87        $ECHO $1 failed
88        exit_script 2
89     fi
90 }
91
92 set_downloader() {
93     test_program_installed wget
94     if [[ $? -ne 0 ]] ; then
95         DOWNLOADER=wget
96         DOWNLOADER_NAME=wget
97         return
98     fi
99     test_program_installed curl
100     if [[ $? -ne 0 ]] ; then
101         DOWNLOADER="curl -f -O"
102         DOWNLOADER_NAME=curl
103         return
104     fi
105     $ECHO "error: wget or curl required"
106     exit_script 11
107 }
108
109 set_md5sum() {
110     test_program_installed md5sum
111     if [[ $? -ne 0 ]] ; then
112         MD5SUM=md5sum
113     else
114         MD5SUM="md5 -r"
115     fi
116 }
117
118 semver_into() {
119     RE_SEMVER="^([0-9]*)\.([0-9]*)\.([0-9]*)-?(.*)?$" # 3.3.3-5
120     CLANG_RE_OLD="^([0-9]*)\.([0-9]*)-?(.*)?$" # 3.3-5
121     if [[ $1 =~ $RE_SEMVER ]] ; then
122         export "$2=${BASH_REMATCH[1]}"
123         export "$3=${BASH_REMATCH[2]}"
124         export "$4=${BASH_REMATCH[3]}"
125         export "$5=${BASH_REMATCH[4]}"
126     elif [[ $1 =~ $CLANG_RE_OLD ]] ; then
127         export "$2=${BASH_REMATCH[1]}"
128         export "$3=${BASH_REMATCH[2]}"
129         export "$4=0"
130         export "$5=${BASH_REMATCH[3]}"
131     else
132         echo "unsupported version number, please report a bug: $1"
133         exit 123
134     fi
135 }
136
137 clang_version_ok() {
138     CLANG_VERSION=$(clang --version | head -n1)
139     CLANG_VERSION_RE='^[a-zA-Z0-9 ]* version (.*)$' # 3.3-5
140     if [[ $CLANG_VERSION =~ $CLANG_VERSION_RE ]] ; then
141         export "CLANG_VERSION=${BASH_REMATCH[1]}"
142         local CLANG_MAJOR CLANG_MINOR CLANG_PATCH CLANG_SPECIAL
143         semver_into "$CLANG_VERSION" CLANG_MAJOR CLANG_MINOR CLANG_PATCH CLANG_SPECIAL
144         if [[ $CLANG_MAJOR -lt 3
145             || ( $CLANG_MAJOR -eq 3 && $CLANG_MINOR -le 1 )
146             ]] ; then
147             echo "clang version required >= $REQUIRE_CLANG_VERSION, got $CLANG_VERSION"
148             return 1
149         fi
150     else
151         return 1
152     fi
153     return 0
154 }
155
156 set_cc() {
157     test_programs_installed clang clang++
158     if [[ $? -ne 0 ]] && clang_version_ok ; then
159         [ -z "$CC" ] && CC=clang
160         [ -z "$CXX" ] && CXX=clang++
161         return
162     fi
163
164     test_programs_installed gcc g++
165     if [[ $? -ne 0 ]] ; then
166         [ -z "$CC" ] && CC=gcc
167         [ -z "$CXX" ] && CXX=g++
168         return
169     fi
170
171     $ECHO "error: high enough version of either (clang/clang++) or (gcc/g++) required!"
172     exit_script 10
173 }
174
175 set_make() {
176     case $OS in
177         freebsd) MAKE=gmake ;;
178         *) MAKE=make ;;
179     esac
180     if [[ $MAKE = 'gmake' ]] ; then
181         ensure_program_installed gmake
182     fi
183 }
184
185 check_installed_programs() {
186     ensure_program_installed chmod
187     ensure_program_installed uname
188     ensure_program_installed git
189     ensure_program_installed wget curl
190     ensure_program_installed clang gcc
191     ensure_program_installed clang++ g++ cl
192     ensure_program_installed make gmake
193     ensure_program_installed md5sum md5
194     ensure_program_installed cut
195 }
196
197 check_library_exists() {
198     GCC_TEST=factor-library-test.c
199     GCC_OUT=factor-library-test.out
200     $ECHO -n "Checking for library $1..."
201     $ECHO "int main(){return 0;}" > $GCC_TEST
202     $CC $GCC_TEST -o $GCC_OUT -l $1 2>&-
203     if [[ $? -ne 0 ]] ; then
204         $ECHO "not found."
205     else
206         $ECHO "found."
207     fi
208     $DELETE -f $GCC_TEST
209     check_ret $DELETE
210     $DELETE -f $GCC_OUT
211     check_ret $DELETE
212 }
213
214 check_X11_libraries() {
215     check_library_exists GL
216     check_library_exists X11
217     check_library_exists pango-1.0
218 }
219
220 check_gtk_libraries() {
221     check_library_exists gobject-2.0
222     check_library_exists gtk-x11-2.0
223     check_library_exists gdk-x11-2.0
224     check_library_exists gdk_pixbuf-2.0
225     check_library_exists gtkglext-x11-1.0
226     check_library_exists atk-1.0
227     check_library_exists gio-2.0
228     check_library_exists gdkglext-x11-1.0
229     check_library_exists pango-1.0
230 }
231
232
233 check_libraries() {
234     case $OS in
235             linux) check_X11_libraries
236                    check_gtk_libraries;;
237             unix) check_gtk_libraries;;
238     esac
239 }
240
241 check_factor_exists() {
242     if [[ -d "factor" ]] ; then
243         $ECHO "A directory called 'factor' already exists."
244         $ECHO "Rename or delete it and try again."
245         exit_script 4
246     fi
247 }
248
249 find_os() {
250     if [[ -n $OS ]] ; then return; fi
251     $ECHO "Finding OS..."
252     local uname_s=$(uname -s)
253     check_ret uname
254     case $uname_s in
255         CYGWIN_NT-5.2-WOW64) OS=windows;;
256         *CYGWIN_NT*) OS=windows;;
257         *CYGWIN*) OS=windows;;
258         MINGW32*) OS=windows;;
259         MSYS_NT*) OS=windows;;
260         *darwin*) OS=macosx;;
261         *Darwin*) OS=macosx;;
262         *linux*) OS=linux;;
263         *Linux*) OS=linux;;
264         FreeBSD) OS=freebsd;;
265     esac
266 }
267
268 find_architecture() {
269     if [[ -n $ARCH ]] ; then return; fi
270     $ECHO "Finding ARCH..."
271     uname_m=$(uname -m)
272     check_ret uname
273     case $uname_m in
274        i386) ARCH=x86;;
275        i686) ARCH=x86;;
276        i86pc) ARCH=x86;;
277        amd64) ARCH=x86;;
278        ppc64) ARCH=ppc;;
279        *86) ARCH=x86;;
280        *86_64) ARCH=x86;;
281        "Power Macintosh") ARCH=ppc;;
282     esac
283 }
284
285 find_num_cores() {
286     $ECHO "Finding num cores..."
287     NUM_CORES=1
288     uname_s=$(uname -s)
289     check_ret uname
290     case $uname_s in
291         CYGWIN_NT-5.2-WOW64 | *CYGWIN_NT* | *CYGWIN* | MINGW32*) NUM_CORES=$NUMBER_OF_PROCESSORS;;
292         *darwin* | *Darwin* | *linux* | *Linux*) NUM_CORES=$(getconf _NPROCESSORS_ONLN);;
293         freebsd) NUM_CORES=$(sysctl -n hw.ncpu);;
294     esac
295 }
296
297 echo_test_program() {
298     #! Must be 'echo'
299     echo -e "int main(){ return (long)(8*sizeof(void*)); }"
300 }
301
302 c_find_word_size() {
303     $ECHO "Finding WORD..."
304     C_WORD="factor-word-size"
305     echo_test_program | $CC -o $C_WORD -xc -
306     check_ret $CC
307     ./$C_WORD
308     WORD=$?
309     $DELETE -f $C_WORD
310 }
311
312 intel_macosx_word_size() {
313     ensure_program_installed sysctl
314     $ECHO -n "Testing if your Intel Mac supports 64bit binaries..."
315     sysctl machdep.cpu.extfeatures | grep EM64T >/dev/null
316     if [[ $? -eq 0 ]] ; then
317         WORD=64
318         $ECHO "yes!"
319     else
320         WORD=32
321         $ECHO "no."
322     fi
323 }
324
325 find_word_size() {
326     if [[ -n $WORD ]] ; then return; fi
327     if [[ $OS == macosx && $ARCH == x86 ]] ; then
328         intel_macosx_word_size
329     else
330         c_find_word_size
331     fi
332 }
333
334 set_factor_binary() {
335     case $OS in
336         windows) FACTOR_BINARY=factor.com;;
337         *) FACTOR_BINARY=factor;;
338     esac
339 }
340
341 set_factor_library() {
342     case $OS in
343         windows) FACTOR_LIBRARY=factor.dll;;
344         macosx) FACTOR_LIBRARY=libfactor.dylib;;
345         *) FACTOR_LIBRARY=libfactor.a;;
346     esac
347 }
348
349 set_factor_image() {
350     FACTOR_IMAGE=factor.image
351     FACTOR_IMAGE_FRESH=factor.image.fresh
352 }
353
354 echo_build_info() {
355     $ECHO OS=$OS
356     $ECHO ARCH=$ARCH
357     $ECHO NUM_CORES=$NUM_CORES
358     $ECHO WORD=$WORD
359     $ECHO DEBUG=$DEBUG
360     $ECHO CURRENT_BRANCH=$CURRENT_BRANCH
361     $ECHO FACTOR_BINARY=$FACTOR_BINARY
362     $ECHO FACTOR_LIBRARY=$FACTOR_LIBRARY
363     $ECHO FACTOR_IMAGE=$FACTOR_IMAGE
364     $ECHO MAKE_TARGET=$MAKE_TARGET
365     $ECHO BOOT_IMAGE=$BOOT_IMAGE
366     $ECHO MAKE_IMAGE_TARGET=$MAKE_IMAGE_TARGET
367     $ECHO GIT_PROTOCOL=$GIT_PROTOCOL
368     $ECHO GIT_URL=$GIT_URL
369     $ECHO DOWNLOADER=$DOWNLOADER
370     $ECHO CC=$CC
371     $ECHO CXX=$CXX
372     $ECHO MAKE=$MAKE
373     $ECHO COPY=$COPY
374     $ECHO DELETE=$DELETE
375 }
376
377 check_os_arch_word() {
378     if ! [[ -n $OS && -n $ARCH && -n $WORD ]] ; then
379         $ECHO "OS: $OS"
380         $ECHO "ARCH: $ARCH"
381         $ECHO "WORD: $WORD"
382         $ECHO "OS, ARCH, or WORD is empty.  Please report this."
383
384         $ECHO $MAKE_TARGET
385         exit_script 5
386     fi
387 }
388
389 set_build_info() {
390     check_os_arch_word
391     if [[ $OS == linux && $ARCH == ppc ]] ; then
392         MAKE_IMAGE_TARGET=linux-ppc.32
393         MAKE_TARGET=linux-ppc-32
394     elif [[ $OS == windows && $ARCH == x86 && $WORD == 64 ]] ; then
395         MAKE_IMAGE_TARGET=windows-x86.64
396         MAKE_TARGET=windows-x86-64
397     elif [[ $OS == windows && $ARCH == x86 && $WORD == 32 ]] ; then
398         MAKE_IMAGE_TARGET=windows-x86.32
399         MAKE_TARGET=windows-x86-32
400     elif [[ $ARCH == x86 && $WORD == 64 ]] ; then
401         MAKE_IMAGE_TARGET=unix-x86.64
402         MAKE_TARGET=$OS-x86-64
403     elif [[ $ARCH == x86 && $WORD == 32 ]] ; then
404         MAKE_IMAGE_TARGET=unix-x86.32
405         MAKE_TARGET=$OS-x86-32
406     else
407         MAKE_IMAGE_TARGET=$ARCH.$WORD
408         MAKE_TARGET=$OS-$ARCH-$WORD
409     fi
410     BOOT_IMAGE=boot.$MAKE_IMAGE_TARGET.image
411 }
412
413 parse_build_info() {
414     ensure_program_installed cut
415     $ECHO "Parsing make target from command line: $1"
416     OS=$(echo $1 | cut -d '-' -f 1)
417     ARCH=$(echo $1 | cut -d '-' -f 2)
418     WORD=$(echo $1 | cut -d '-' -f 3)
419
420     if [[ $OS == linux && $ARCH == ppc ]] ; then WORD=32; fi
421     if [[ $OS == linux && $ARCH == arm ]] ; then WORD=32; fi
422     if [[ $OS == macosx && $ARCH == ppc ]] ; then WORD=32; fi
423
424     $ECHO "OS=$OS"
425     $ECHO "ARCH=$ARCH"
426     $ECHO "WORD=$WORD"
427 }
428
429 find_build_info() {
430     find_os
431     find_architecture
432     find_num_cores
433     set_cc
434     find_word_size
435     set_current_branch
436     set_factor_binary
437     set_factor_library
438     set_factor_image
439     set_build_info
440     set_downloader
441     set_make
442     echo_build_info
443 }
444
445 invoke_git() {
446     git "$@"
447     check_ret git
448 }
449
450 git_clone() {
451     $ECHO "Downloading the git repository from factorcode.org..."
452     invoke_git clone $GIT_URL
453 }
454
455 update_script_name() {
456     $ECHO "$(dirname $0)/_update.sh"
457 }
458
459 update_script() {
460     local -r update_script=$(update_script_name)
461     local -r bash_path=$(which bash)
462     $ECHO "#!$bash_path" >"$update_script"
463     $ECHO "git pull \"$GIT_URL\" master" >>"$update_script"
464     $ECHO "if [[ \$? -eq 0 ]]; then exec \"$0\" $SCRIPT_ARGS; else echo \"git pull failed\"; exit 2; fi" \
465         >>"$update_script"
466     $ECHO "exit 0" >>"$update_script"
467
468     chmod 755 "$update_script"
469     exec "$update_script"
470 }
471
472 update_script_changed() {
473     invoke_git diff --stat "$(invoke_git merge-base HEAD FETCH_HEAD)" FETCH_HEAD | grep 'build\.sh' >/dev/null
474 }
475
476 git_fetch_factorcode() {
477     $ECHO "Fetching the git repository from factorcode.org..."
478
479     rm -f "$(update_script_name)"
480     invoke_git fetch "$GIT_URL" master
481
482     if update_script_changed; then
483         $ECHO "Updating and restarting the build.sh script..."
484         update_script
485     else
486         $ECHO "Updating the working tree..."
487         invoke_git pull "$GIT_URL" master
488     fi
489 }
490
491 cd_factor() {
492     cd "factor"
493     check_ret cd
494 }
495
496 set_copy() {
497     case $OS in
498         windows) COPY=cp;;
499         *) COPY=cp;;
500     esac
501 }
502
503 set_delete() {
504     case $OS in
505         windows) DELETE=rm;;
506         *) DELETE=rm;;
507     esac
508 }
509
510 backup_factor() {
511     $ECHO "Backing up factor..."
512     $COPY $FACTOR_BINARY $FACTOR_BINARY.bak
513     $COPY $FACTOR_LIBRARY $FACTOR_LIBRARY.bak
514     $COPY $BOOT_IMAGE $BOOT_IMAGE.bak
515     $COPY $FACTOR_IMAGE $FACTOR_IMAGE.bak
516     $ECHO "Done with backup."
517 }
518
519 check_makefile_exists() {
520     if [[ ! -e "GNUmakefile" ]] ; then
521         $ECHO ""
522         $ECHO "***GNUmakefile not found***"
523         $ECHO "You are likely in the wrong directory."
524         $ECHO "Run this script from your factor directory:"
525         $ECHO "     ./build.sh"
526         exit_script 6
527     fi
528 }
529
530 invoke_make() {
531     check_makefile_exists
532     $MAKE $MAKE_OPTS "$@"
533     check_ret $MAKE
534 }
535
536 make_clean() {
537     invoke_make clean
538 }
539
540 make_factor() {
541     $ECHO "Building factor with $NUM_CORES cores"
542     invoke_make CC=$CC CXX=$CXX $MAKE_TARGET -j$NUM_CORES
543 }
544
545 make_clean_factor() {
546     make_clean
547     make_factor
548 }
549
550 current_git_branch() {
551     git rev-parse --abbrev-ref HEAD
552 }
553
554 check_url() {
555     if [[ $DOWNLOADER_NAME == 'wget' ]]; then
556         if [[ $(wget -S --spider $1 2>&1 | grep 'HTTP/1.1 200 OK') ]]; then
557             return 0
558         else
559             return 1
560         fi
561     elif [[ $DOWNLOADER_NAME == 'curl' ]]; then
562         local code=$(curl -sL -w "%{http_code}\\n" "$1" -o /dev/null)
563         if [[ $code -eq 200 ]]; then return 0; else return 1; fi
564     else
565         $ECHO "error: wget or curl required in check_url"
566         exit_script 12
567     fi
568 }
569
570 # If we are on a branch, first try to get a boot image for that branch.
571 # Otherwise, just use `master`
572 set_boot_image_vars() {
573     set_current_branch
574     local url="http://downloads.factorcode.org/images/${CURRENT_BRANCH}/checksums.txt"
575     check_url $url
576     if [[ $? -eq 0 ]]; then
577         CHECKSUM_URL="$url"
578         BOOT_IMAGE_URL="http://downloads.factorcode.org/images/${CURRENT_BRANCH}/${BOOT_IMAGE}"
579     else
580         CHECKSUM_URL="http://downloads.factorcode.org/images/master/checksums.txt"
581         BOOT_IMAGE_URL="http://downloads.factorcode.org/images/master/${BOOT_IMAGE}"
582     fi
583 }
584
585 set_current_branch() {
586     if [ -n "${CI_BRANCH}" ]; then
587         CURRENT_BRANCH="${CI_BRANCH}"
588     else
589         CURRENT_BRANCH=$(current_git_branch)
590     fi
591 }
592
593 update_boot_image() {
594     set_boot_image_vars
595     $ECHO "Deleting old images..."
596     $DELETE checksums.txt* > /dev/null 2>&1
597     # delete boot images with one or two characters after the dot
598     $DELETE $BOOT_IMAGE.{?,??} > /dev/null 2>&1
599     $DELETE temp/staging.*.image > /dev/null 2>&1
600     if [[ -f $BOOT_IMAGE ]] ; then
601         get_url $CHECKSUM_URL
602         local factorcode_md5=$(cat checksums.txt | grep $BOOT_IMAGE | cut -f2 -d' ')
603         set_md5sum
604         local disk_md5=$($MD5SUM $BOOT_IMAGE | cut -f1 -d' ')
605         $ECHO "Factorcode md5: $factorcode_md5";
606         $ECHO "Disk md5: $disk_md5";
607         if [[ "$factorcode_md5" == "$disk_md5" ]] ; then
608             $ECHO "Your disk boot image matches the one on factorcode.org."
609         else
610             $DELETE $BOOT_IMAGE > /dev/null 2>&1
611             get_boot_image
612         fi
613     else
614         get_boot_image
615     fi
616 }
617
618 get_boot_image() {
619     $ECHO "Downloading boot image $BOOT_IMAGE."
620     get_url "${BOOT_IMAGE_URL}"
621 }
622
623 get_url() {
624     if [[ -z $DOWNLOADER ]] ; then
625         set_downloader;
626     fi
627     $ECHO $DOWNLOADER $1 ;
628     $DOWNLOADER $1
629     check_ret $DOWNLOADER
630 }
631
632 get_config_info() {
633     find_build_info
634     check_installed_programs
635     check_libraries
636 }
637
638 copy_fresh_image() {
639     $ECHO "Copying $FACTOR_IMAGE to $FACTOR_IMAGE_FRESH..."
640     $COPY $FACTOR_IMAGE $FACTOR_IMAGE_FRESH
641 }
642
643 bootstrap() {
644     ./$FACTOR_BINARY -i=$BOOT_IMAGE
645     copy_fresh_image
646 }
647
648 install() {
649     check_factor_exists
650     get_config_info
651     git_clone
652     cd_factor
653     make_factor
654     set_boot_image_vars
655     get_boot_image
656     bootstrap
657 }
658
659 update() {
660     get_config_info
661     git_fetch_factorcode
662     backup_factor
663     make_clean_factor
664 }
665
666 download_and_bootstrap() {
667     update_boot_image
668     bootstrap
669 }
670
671 net_bootstrap_no_pull() {
672     get_config_info
673     make_clean_factor
674     download_and_bootstrap
675 }
676
677 refresh_image() {
678     ./$FACTOR_BINARY -e="USING: vocabs.loader vocabs.refresh system memory ; refresh-all save 0 exit"
679     check_ret factor
680 }
681
682 make_boot_image() {
683     ./$FACTOR_BINARY -e="\"$MAKE_IMAGE_TARGET\" USING: system bootstrap.image memory ; make-image save 0 exit"
684     check_ret factor
685 }
686
687 install_deps_apt() {
688     sudo apt install --yes libc6-dev libpango1.0-dev libx11-dev xorg-dev libgtk2.0-dev gtk2-engines-pixbuf libgtkglext1-dev wget git git-doc rlwrap clang gcc make screen tmux libssl-dev g++
689     check_ret sudo
690 }
691
692 install_deps_pacman() {
693     sudo pacman --noconfirm -Syu gcc clang make rlwrap git wget pango glibc gtk2 gtk3 gtkglext gtk-engines gdk-pixbuf2 libx11 screen tmux
694     check_ret sudo
695 }
696
697 install_deps_dnf() {
698     sudo dnf --assumeyes install gcc gcc-c++ glibc-devel binutils libX11-devel pango-devel gtk3-devel gdk-pixbuf2-devel gtkglext-devel tmux rlwrap wget
699     check_ret sudo
700 }
701
702 install_deps_pkg() {
703     sudo pkg install --yes git gcc rlwrap ripgrep curl gmake x11-toolkits/gtk30 x11-toolkits/gtkglext pango cairo
704 }
705
706
707 install_deps_macosx() {
708     test_program_installed git
709     if [[ $? -ne 1 ]] ; then
710         ensure_program_installed yes
711         $ECHO "git not found."
712         $ECHO "This script requires either git-core or port."
713         $ECHO "If it fails, install git-core or port and try again."
714         ensure_program_installed port
715         $ECHO "Installing git-core with port...this will take awhile."
716         yes | sudo port install git-core
717     fi
718 }
719
720 usage() {
721     $ECHO "usage: $0 command [optional-target]"
722     $ECHO "  install - git clone, compile, bootstrap"
723     $ECHO "  deps-apt - install required packages for Factor on Linux using apt"
724     $ECHO "  deps-pacman - install required packages for Factor on Linux using pacman"
725     $ECHO "  deps-dnf - install required packages for Factor on Linux using dnf"
726     $ECHO "  deps-pkg - install required packages for Factor on FreeBSD using pkg"
727     $ECHO "  deps-macosx - install git on MacOSX using port"
728     $ECHO "  self-update - git pull, recompile, make local boot image, bootstrap"
729     $ECHO "  quick-update - git pull, refresh-all, save"
730     $ECHO "  update|latest - git pull, recompile, download a boot image, bootstrap"
731     $ECHO "  bootstrap - bootstrap with existing boot image"
732     $ECHO "  net-bootstrap - recompile, download a boot image, bootstrap"
733     $ECHO "  make-target - find and print the os-arch-cpu string"
734     $ECHO "  report - print the build variables"
735     $ECHO "  update-boot-image - get the boot image for the current branch of for master"
736     $ECHO ""
737     $ECHO "If you are behind a firewall, invoke as:"
738     $ECHO "env GIT_PROTOCOL=http $0 <command>"
739     $ECHO ""
740     $ECHO "Example for overriding the default target:"
741     $ECHO "    $0 update macosx-x86-32"
742 }
743
744 MAKE_TARGET=unknown
745
746 # -n is nonzero length, -z is zero length
747 if [[ -n "$2" ]] ; then
748     parse_build_info $2
749 fi
750
751 set_copy
752 set_delete
753
754 case "$1" in
755     install) install ;;
756     deps-apt) install_deps_apt ;;
757     deps-pacman) install_deps_pacman ;;
758     deps-macosx) install_deps_macosx ;;
759     deps-dnf) install_deps_dnf ;;
760     deps-pkg) install_deps_pkg ;;
761     self-update) update; make_boot_image; bootstrap;;
762     quick-update) update; refresh_image ;;
763     update) update; download_and_bootstrap ;;
764     latest) update; download_and_bootstrap ;;
765     compile) find_build_info; make_factor ;;
766     bootstrap) get_config_info; bootstrap ;;
767     net-bootstrap) net_bootstrap_no_pull ;;
768     make-target) FIND_MAKE_TARGET=true; ECHO=false; find_build_info; exit_script ;;
769     report) find_build_info ;;
770     full-report) find_build_info; check_installed_programs; check_libraries ;;
771     update-boot-image) find_build_info; check_installed_programs; update_boot_image;;
772     *) usage ;;
773 esac
774